import{s as ht,n as bt,o as vt}from"../chunks/scheduler.d6170356.js";import{S as wt,i as yt,g as s,s as l,r as u,A as $t,h as o,f as i,c as a,j as gt,u as p,x as r,k as Se,y as kt,a as n,v as d,d as c,t as m,w as g}from"../chunks/index.fcd4cc08.js";import{H as h}from"../chunks/Heading.8660bd0e.js";function Tt(We){let f,te,Z,ie,w,ne,y,le,$,Ye="Tasks, or pipeline types, describe the “shape” of each model’s API (inputs and outputs) and are used to determine which Inference API and widget we want to display for any given model.",ae,b,Fe='<img class="block dark:hidden" src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/hub/tasks.png"/> <img class="hidden dark:block" src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/hub/tasks-dark.png"/>',se,k,Ne="This classification is relatively coarse-grained (you can always add more fine-grained task names in your model tags), so <strong>you should rarely have to create a new task</strong>. If you want to add support for a new task, this document explains the required steps.",oe,T,re,x,De="Having a new task integrated into the Hub means that:",fe,H,Ve="<li>Users can search for all models – and datasets – of a given task.</li> <li>The Inference API supports the task.</li> <li>Users can try out models directly with the widget. 🏆</li>",ue,_,Be="Note that you don’t need to implement all the steps by yourself. Adding a new task is a community effort, and multiple people can contribute. 🧑‍🤝‍🧑",pe,P,Ge='To begin the process, open a new issue in the <a href="https://github.com/huggingface/huggingface_hub/issues" rel="nofollow">huggingface_hub</a> repository. Please use the “Adding a new task” template. ⚠️Before doing any coding, it’s suggested to go over this document. ⚠️',de,C,Je="The first step is to upload a model for your proposed task. Once you have a model in the Hub for the new task, the next step is to enable it in the Inference API. There are three types of support that you can choose from:",ce,L,Ke='<li>🤗 using a <code>transformers</code> model</li> <li>🐳 using a model from an <a href="./models-libraries">officially supported library</a></li> <li>🖨️ using a model with custom inference code. This experimental option has downsides, so we recommend using one of the other approaches.</li>',me,M,Qe="Finally, you can add a couple of UI elements, such as the task icon and the widget, that complete the integration in the Hub. 📷",ge,I,Xe="Some steps are orthogonal; you don’t need to do them in order. <strong>You don’t need the Inference API to add the icon.</strong> This means that, even if there isn’t full integration yet, users can still search for models of a given task.",he,A,be,j,ve,U,Ze="If your model is a <code>transformers</code>-based model, there is a 1:1 mapping between the Inference API task and a <code>pipeline</code> class. Here are some example PRs from the <code>transformers</code> library:",we,q,et='<li><a href="https://github.com/huggingface/transformers/pull/11598" rel="nofollow">Adding ImageClassificationPipeline</a></li> <li><a href="https://github.com/huggingface/transformers/pull/13342" rel="nofollow">Adding AudioClassificationPipeline</a></li>',ye,O,tt="Once the pipeline is submitted and deployed, you should be able to use the Inference API for your model.",$e,R,ke,z,it='The Hub also supports over 10 open-source libraries in the <a href="https://github.com/huggingface/api-inference-community" rel="nofollow">Community Inference API</a>.',Te,E,nt="<strong>Adding a new task is relatively straightforward and requires 2 PRs:</strong>",xe,S,lt='<li>PR 1: Add the new task to the API <a href="https://github.com/huggingface/api-inference-community/blob/main/api_inference_community/validation.py" rel="nofollow">validation</a>. This code ensures that the inference input is valid for a given task. Some PR examples:<ul><li><a href="https://github.com/huggingface/huggingface_hub/commit/5f040a117cf2a44d704621012eb41c01b103cfca#diff-db8bbac95c077540d79900384cfd524d451e629275cbb5de7a31fc1cd5d6c189" rel="nofollow">Add text-to-image</a></li> <li><a href="https://github.com/huggingface/huggingface_hub/commit/141e30588a2031d4d5798eaa2c1250d1d1b75905#diff-db8bbac95c077540d79900384cfd524d451e629275cbb5de7a31fc1cd5d6c189" rel="nofollow">Add audio-classification</a></li> <li><a href="https://github.com/huggingface/huggingface_hub/commit/dbea604a45df163d3f0b4b1d897e4b0fb951c650#diff-db8bbac95c077540d79900384cfd524d451e629275cbb5de7a31fc1cd5d6c189" rel="nofollow">Add tabular-classification</a></li></ul></li> <li>PR 2: Add the new task to a library docker image. You should also add a template to <a href="https://github.com/huggingface/api-inference-community/tree/main/docker_images/common/app/pipelines" rel="nofollow"><code>docker_images/common/app/pipelines</code></a> to facilitate integrating the task in other libraries. Here is an example PR:<ul><li><a href="https://github.com/huggingface/huggingface_hub/commit/6926fd9bec23cb963ce3f58ec53496083997f0fa#diff-3f1083a92ca0047b50f9ad2d04f0fe8dfaeee0e26ab71eb8835e365359a1d0dc" rel="nofollow">Add text-classification to spaCy</a></li></ul></li>',He,W,_e,Y,at="<strong>My model is not supported by any library. Am I doomed? 😱</strong>",Pe,F,st='We recommend using <a href="./spaces">Hugging Face Spaces</a> for these use cases.',Ce,N,Le,D,ot="The Hub allows users to filter models by a given task. To do this, you need to add the task to several places. You’ll also get to pick an icon for the task!",Me,V,rt="<li>Add the task type to <code>Types.ts</code></li>",Ie,B,ft='In <a href="https://github.com/huggingface/huggingface.js/blob/main/packages/tasks/src/pipelines.ts" rel="nofollow">huggingface.js/packages/tasks/src/pipelines.ts</a>, you need to do a couple of things',Ae,G,ut='<li>Add the type to <code>PIPELINE_DATA</code>. Note that pipeline types are sorted into different categories (NLP, Audio, Computer Vision, and others).</li> <li>You will also need to fill minor changes in <a href="https://github.com/huggingface/huggingface.js/blob/main/packages/tasks/src/tasks/index.ts" rel="nofollow">huggingface.js/packages/tasks/src/tasks/index.ts</a></li>',je,v,pt="<li>Choose an icon</li>",Ue,J,dt='You can add an icon in the <a href="https://github.com/huggingface/huggingface.js/tree/main/packages/widgets/src/lib/components/Icons" rel="nofollow">lib/Icons</a> directory. We usually choose carbon icons from <a href="https://icones.js.org/collection/carbon" rel="nofollow">https://icones.js.org/collection/carbon</a>. Also add the icon to <a href="https://github.com/huggingface/huggingface.js/blob/main/packages/widgets/src/lib/components/PipelineIcon/PipelineIcon.svelte" rel="nofollow">PipelineIcon</a>.',qe,K,Oe,Q,ct='Once the task is in production, what could be more exciting than implementing some way for users to play directly with the models in their browser? 🤩 You can find all the widgets <a href="https://huggingface.co/spaces/huggingfacejs/inference-widgets" rel="nofollow">here</a>.',Re,X,mt='If you would be interested in contributing with a widget, you can look at the <a href="https://github.com/huggingface/huggingface.js/tree/main/packages/widgets" rel="nofollow">implementation</a> of all the widgets.',ze,ee,Ee;return w=new h({props:{title:"Tasks",local:"tasks",headingTag:"h1"}}),y=new h({props:{title:"What’s a task?",local:"whats-a-task",headingTag:"h2"}}),T=new h({props:{title:"Overview",local:"overview",headingTag:"h2"}}),A=new h({props:{title:"Adding new tasks to the Hub",local:"adding-new-tasks-to-the-hub",headingTag:"h2"}}),j=new h({props:{title:"Using Hugging Face transformers library",local:"using-hugging-face-transformers-library",headingTag:"h3"}}),R=new h({props:{title:"Using Community Inference API with a supported library",local:"using-community-inference-api-with-a-supported-library",headingTag:"h3"}}),W=new h({props:{title:"Adding Community Inference API for a quick prototype",local:"adding-community-inference-api-for-a-quick-prototype",headingTag:"h3"}}),N=new h({props:{title:"UI elements",local:"ui-elements",headingTag:"h3"}}),K=new h({props:{title:"Widget",local:"widget",headingTag:"h3"}}),{c(){f=s("meta"),te=l(),Z=s("p"),ie=l(),u(w.$$.fragment),ne=l(),u(y.$$.fragment),le=l(),$=s("p"),$.textContent=Ye,ae=l(),b=s("div"),b.innerHTML=Fe,se=l(),k=s("p"),k.innerHTML=Ne,oe=l(),u(T.$$.fragment),re=l(),x=s("p"),x.textContent=De,fe=l(),H=s("ul"),H.innerHTML=Ve,ue=l(),_=s("p"),_.textContent=Be,pe=l(),P=s("p"),P.innerHTML=Ge,de=l(),C=s("p"),C.textContent=Je,ce=l(),L=s("ul"),L.innerHTML=Ke,me=l(),M=s("p"),M.textContent=Qe,ge=l(),I=s("p"),I.innerHTML=Xe,he=l(),u(A.$$.fragment),be=l(),u(j.$$.fragment),ve=l(),U=s("p"),U.innerHTML=Ze,we=l(),q=s("ul"),q.innerHTML=et,ye=l(),O=s("p"),O.textContent=tt,$e=l(),u(R.$$.fragment),ke=l(),z=s("p"),z.innerHTML=it,Te=l(),E=s("p"),E.innerHTML=nt,xe=l(),S=s("ul"),S.innerHTML=lt,He=l(),u(W.$$.fragment),_e=l(),Y=s("p"),Y.innerHTML=at,Pe=l(),F=s("p"),F.innerHTML=st,Ce=l(),u(N.$$.fragment),Le=l(),D=s("p"),D.textContent=ot,Me=l(),V=s("ol"),V.innerHTML=rt,Ie=l(),B=s("p"),B.innerHTML=ft,Ae=l(),G=s("ul"),G.innerHTML=ut,je=l(),v=s("ol"),v.innerHTML=pt,Ue=l(),J=s("p"),J.innerHTML=dt,qe=l(),u(K.$$.fragment),Oe=l(),Q=s("p"),Q.innerHTML=ct,Re=l(),X=s("p"),X.innerHTML=mt,ze=l(),ee=s("p"),this.h()},l(e){const t=$t("svelte-u9bgzb",document.head);f=o(t,"META",{name:!0,content:!0}),t.forEach(i),te=a(e),Z=o(e,"P",{}),gt(Z).forEach(i),ie=a(e),p(w.$$.fragment,e),ne=a(e),p(y.$$.fragment,e),le=a(e),$=o(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-1eg00uh"&&($.textContent=Ye),ae=a(e),b=o(e,"DIV",{class:!0,"data-svelte-h":!0}),r(b)!=="svelte-1lsch2v"&&(b.innerHTML=Fe),se=a(e),k=o(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-1w57hvb"&&(k.innerHTML=Ne),oe=a(e),p(T.$$.fragment,e),re=a(e),x=o(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-15av66z"&&(x.textContent=De),fe=a(e),H=o(e,"UL",{"data-svelte-h":!0}),r(H)!=="svelte-8gq8pt"&&(H.innerHTML=Ve),ue=a(e),_=o(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-tuuwdi"&&(_.textContent=Be),pe=a(e),P=o(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-1xa8q81"&&(P.innerHTML=Ge),de=a(e),C=o(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-1ncnre8"&&(C.textContent=Je),ce=a(e),L=o(e,"UL",{"data-svelte-h":!0}),r(L)!=="svelte-iyd5dv"&&(L.innerHTML=Ke),me=a(e),M=o(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-18hwl3y"&&(M.textContent=Qe),ge=a(e),I=o(e,"P",{"data-svelte-h":!0}),r(I)!=="svelte-1qljhbq"&&(I.innerHTML=Xe),he=a(e),p(A.$$.fragment,e),be=a(e),p(j.$$.fragment,e),ve=a(e),U=o(e,"P",{"data-svelte-h":!0}),r(U)!=="svelte-tokqq5"&&(U.innerHTML=Ze),we=a(e),q=o(e,"UL",{"data-svelte-h":!0}),r(q)!=="svelte-m5tbso"&&(q.innerHTML=et),ye=a(e),O=o(e,"P",{"data-svelte-h":!0}),r(O)!=="svelte-1rm7guk"&&(O.textContent=tt),$e=a(e),p(R.$$.fragment,e),ke=a(e),z=o(e,"P",{"data-svelte-h":!0}),r(z)!=="svelte-u8woez"&&(z.innerHTML=it),Te=a(e),E=o(e,"P",{"data-svelte-h":!0}),r(E)!=="svelte-pvk38g"&&(E.innerHTML=nt),xe=a(e),S=o(e,"UL",{"data-svelte-h":!0}),r(S)!=="svelte-9oxdcc"&&(S.innerHTML=lt),He=a(e),p(W.$$.fragment,e),_e=a(e),Y=o(e,"P",{"data-svelte-h":!0}),r(Y)!=="svelte-1rw0of7"&&(Y.innerHTML=at),Pe=a(e),F=o(e,"P",{"data-svelte-h":!0}),r(F)!=="svelte-18pm6ym"&&(F.innerHTML=st),Ce=a(e),p(N.$$.fragment,e),Le=a(e),D=o(e,"P",{"data-svelte-h":!0}),r(D)!=="svelte-p8vjj8"&&(D.textContent=ot),Me=a(e),V=o(e,"OL",{"data-svelte-h":!0}),r(V)!=="svelte-1jsxx4s"&&(V.innerHTML=rt),Ie=a(e),B=o(e,"P",{"data-svelte-h":!0}),r(B)!=="svelte-1uzhqbb"&&(B.innerHTML=ft),Ae=a(e),G=o(e,"UL",{"data-svelte-h":!0}),r(G)!=="svelte-swx4ji"&&(G.innerHTML=ut),je=a(e),v=o(e,"OL",{start:!0,"data-svelte-h":!0}),r(v)!=="svelte-ppajzd"&&(v.innerHTML=pt),Ue=a(e),J=o(e,"P",{"data-svelte-h":!0}),r(J)!=="svelte-170oba6"&&(J.innerHTML=dt),qe=a(e),p(K.$$.fragment,e),Oe=a(e),Q=o(e,"P",{"data-svelte-h":!0}),r(Q)!=="svelte-1xlspt7"&&(Q.innerHTML=ct),Re=a(e),X=o(e,"P",{"data-svelte-h":!0}),r(X)!=="svelte-z2f4h"&&(X.innerHTML=mt),ze=a(e),ee=o(e,"P",{}),gt(ee).forEach(i),this.h()},h(){Se(f,"name","hf:doc:metadata"),Se(f,"content",xt),Se(b,"class","flex justify-center"),Se(v,"start","2")},m(e,t){kt(document.head,f),n(e,te,t),n(e,Z,t),n(e,ie,t),d(w,e,t),n(e,ne,t),d(y,e,t),n(e,le,t),n(e,$,t),n(e,ae,t),n(e,b,t),n(e,se,t),n(e,k,t),n(e,oe,t),d(T,e,t),n(e,re,t),n(e,x,t),n(e,fe,t),n(e,H,t),n(e,ue,t),n(e,_,t),n(e,pe,t),n(e,P,t),n(e,de,t),n(e,C,t),n(e,ce,t),n(e,L,t),n(e,me,t),n(e,M,t),n(e,ge,t),n(e,I,t),n(e,he,t),d(A,e,t),n(e,be,t),d(j,e,t),n(e,ve,t),n(e,U,t),n(e,we,t),n(e,q,t),n(e,ye,t),n(e,O,t),n(e,$e,t),d(R,e,t),n(e,ke,t),n(e,z,t),n(e,Te,t),n(e,E,t),n(e,xe,t),n(e,S,t),n(e,He,t),d(W,e,t),n(e,_e,t),n(e,Y,t),n(e,Pe,t),n(e,F,t),n(e,Ce,t),d(N,e,t),n(e,Le,t),n(e,D,t),n(e,Me,t),n(e,V,t),n(e,Ie,t),n(e,B,t),n(e,Ae,t),n(e,G,t),n(e,je,t),n(e,v,t),n(e,Ue,t),n(e,J,t),n(e,qe,t),d(K,e,t),n(e,Oe,t),n(e,Q,t),n(e,Re,t),n(e,X,t),n(e,ze,t),n(e,ee,t),Ee=!0},p:bt,i(e){Ee||(c(w.$$.fragment,e),c(y.$$.fragment,e),c(T.$$.fragment,e),c(A.$$.fragment,e),c(j.$$.fragment,e),c(R.$$.fragment,e),c(W.$$.fragment,e),c(N.$$.fragment,e),c(K.$$.fragment,e),Ee=!0)},o(e){m(w.$$.fragment,e),m(y.$$.fragment,e),m(T.$$.fragment,e),m(A.$$.fragment,e),m(j.$$.fragment,e),m(R.$$.fragment,e),m(W.$$.fragment,e),m(N.$$.fragment,e),m(K.$$.fragment,e),Ee=!1},d(e){e&&(i(te),i(Z),i(ie),i(ne),i(le),i($),i(ae),i(b),i(se),i(k),i(oe),i(re),i(x),i(fe),i(H),i(ue),i(_),i(pe),i(P),i(de),i(C),i(ce),i(L),i(me),i(M),i(ge),i(I),i(he),i(be),i(ve),i(U),i(we),i(q),i(ye),i(O),i($e),i(ke),i(z),i(Te),i(E),i(xe),i(S),i(He),i(_e),i(Y),i(Pe),i(F),i(Ce),i(Le),i(D),i(Me),i(V),i(Ie),i(B),i(Ae),i(G),i(je),i(v),i(Ue),i(J),i(qe),i(Oe),i(Q),i(Re),i(X),i(ze),i(ee)),i(f),g(w,e),g(y,e),g(T,e),g(A,e),g(j,e),g(R,e),g(W,e),g(N,e),g(K,e)}}}const xt='{"title":"Tasks","local":"tasks","sections":[{"title":"What’s a task?","local":"whats-a-task","sections":[],"depth":2},{"title":"Overview","local":"overview","sections":[],"depth":2},{"title":"Adding new tasks to the Hub","local":"adding-new-tasks-to-the-hub","sections":[{"title":"Using Hugging Face transformers library","local":"using-hugging-face-transformers-library","sections":[],"depth":3},{"title":"Using Community Inference API with a supported library","local":"using-community-inference-api-with-a-supported-library","sections":[],"depth":3},{"title":"Adding Community Inference API for a quick prototype","local":"adding-community-inference-api-for-a-quick-prototype","sections":[],"depth":3},{"title":"UI elements","local":"ui-elements","sections":[],"depth":3},{"title":"Widget","local":"widget","sections":[],"depth":3}],"depth":2}],"depth":1}';function Ht(We){return vt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Lt extends wt{constructor(f){super(),yt(this,f,Ht,Tt,ht,{})}}export{Lt as component};
